<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Accessories: D:/Mes documents/Trusty/Arduino/Libraries/Accessories/src/AccessoryGroup.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Accessories
   </div>
   <div id="projectbrief">Arduino for motors and lights library.</div>
  </td>
   <td>        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
</td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('AccessoryGroup_8hpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">AccessoryGroup.hpp</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#ifndef __accessoryGroup_H__</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#define __accessoryGroup_H__</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;Accessory.hpp&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;Chain.hpp&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#ifndef NO_GROUP</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div><div class="line"><a name="l00015"></a><span class="lineno"><a class="line" href="classGroupStateItem.html">   15</a></span>&#160;<span class="keyword">class </span><a class="code" href="classGroupStateItem.html">GroupStateItem</a></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;{</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classGroupState.html">GroupState</a>;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        <a class="code" href="classAccessory.html">Accessory</a> *pAccessory;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        ACC_STATE State;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Delay;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="classGroupStateItem.html#aeff7b5a373dbb6fbf6d2ec27ae846fa1">   29</a></span>&#160;        <a class="code" href="classGroupStateItem.html#aeff7b5a373dbb6fbf6d2ec27ae846fa1">GroupStateItem</a>() { this-&gt;pAccessory = NULL; this-&gt;State = STATE_NONE; this-&gt;Delay = 0; }</div><div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="classGroupStateItem.html#afd18dc4751ac00a4e9e2e824773b108f">   35</a></span>&#160;        <a class="code" href="classGroupStateItem.html#afd18dc4751ac00a4e9e2e824773b108f">GroupStateItem</a>(<a class="code" href="classAccessory.html">Accessory</a> *inpAccessory, ACC_STATE inState, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> inDelay = 0) { this-&gt;pAccessory = inpAccessory; this-&gt;State = inState; this-&gt;Delay = inDelay; }</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_PRINT_ACCESSORIES</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        <span class="keywordtype">void</span> printAccessory();</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;};</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="classGroupState.html">   48</a></span>&#160;<span class="keyword">class </span><a class="code" href="classGroupState.html">GroupState</a></div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;{</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> Id;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        <a class="code" href="classACCSCHAINEDLIST.html">ACCSCHAINEDLIST&lt;GroupStateItem&gt;</a> Items;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        <span class="keywordtype">bool</span> Synchronous;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> startActionTime;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00065"></a><span class="lineno"><a class="line" href="classGroupState.html#abd63266166b098086d0ccebf98b0e269">   65</a></span>&#160;        <a class="code" href="classGroupState.html#abd63266166b098086d0ccebf98b0e269">GroupState</a>() { this-&gt;Id = UNDEFINED_ID; this-&gt;Synchronous = <span class="keyword">false</span>; }</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        <a class="code" href="classGroupState.html#abd63266166b098086d0ccebf98b0e269">GroupState</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, <span class="keywordtype">bool</span> inSynchronous = <span class="keyword">true</span>);</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classGroupState.html#a97d7335581b8417e3a4ebf7632d6292c">begin</a>();</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    </div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classGroupState.html#acf65dca9f5cb8a4ef1f1a07ab0a888b2">StartAction</a>();</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div><div class="line"><a name="l00085"></a><span class="lineno"><a class="line" href="classGroupState.html#ad9503817779a2774923562e80e812a37">   85</a></span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classGroupState.html#ad9503817779a2774923562e80e812a37">ResetAction</a>()  { this-&gt;Items.<a class="code" href="classACCSCHAINEDLIST.html#ac7147ad27413bf0439855df743886053">ResetCurrent</a>(); }</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div><div class="line"><a name="l00090"></a><span class="lineno"><a class="line" href="classGroupState.html#a447de3adf2c1d8e069d1e6480dec9956">   90</a></span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="classGroupState.html#a447de3adf2c1d8e069d1e6480dec9956">IsActionItemPending</a>()  { <span class="keywordflow">return</span> this-&gt;Items.<a class="code" href="classACCSCHAINEDLIST.html#aec3d93b7e6c96031af848629d72905bd">HasCurrent</a>(); }</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div><div class="line"><a name="l00095"></a><span class="lineno"><a class="line" href="classGroupState.html#a8500c1d72dacb2c210cb243ab6ad849d">   95</a></span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classGroupState.html#a8500c1d72dacb2c210cb243ab6ad849d">GetId</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> this-&gt;Id; }</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classGroupState.html#aff83f7f1ac81f36355ead09c92ea093c">loop</a>();</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classGroupState.html#a5d3809e4d9e2bcf71f64a32e4152ebb4">Add</a>(<a class="code" href="classAccessory.html">Accessory</a> *inpAccessory, ACC_STATE inState, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> inDelay = 0);</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_PRINT_ACCESSORIES</span></div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;        <span class="keywordtype">void</span> printAccessory();</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;};</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;</div><div class="line"><a name="l00120"></a><span class="lineno"><a class="line" href="classAccessoryGroup.html">  120</a></span>&#160;<span class="keyword">class </span><a class="code" href="classAccessoryGroup.html">AccessoryGroup</a></div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;{</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        <span class="keyword">static</span> <a class="code" href="classAccessoryGroup.html">AccessoryGroup</a> *pFirstGroup;</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        <span class="keyword">inline</span> <span class="keywordtype">void</span> SetNextGroup(<a class="code" href="classAccessoryGroup.html">AccessoryGroup</a> *inAccessory) { this-&gt;pNextGroup = inAccessory; }</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        <span class="keyword">inline</span> <a class="code" href="classAccessoryGroup.html">AccessoryGroup</a> *GetNextGroup()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> this-&gt;pNextGroup; }</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">void</span> AddGroup(<a class="code" href="classAccessoryGroup.html">AccessoryGroup</a> *inGroup);</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        <a class="code" href="classAccessoryGroup.html">AccessoryGroup</a> *pNextGroup;</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        <a class="code" href="classACCSCHAINEDLIST.html">ACCSCHAINEDLIST&lt;GroupState&gt;</a> States;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        <span class="comment">/*Default constructor.*/</span></div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        <a class="code" href="classAccessoryGroup.html">AccessoryGroup</a>();</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classAccessoryGroup.html#a1ba534d4bee2acdb03fa9fbd94d4c871">begin</a>();</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div><div class="line"><a name="l00140"></a><span class="lineno"><a class="line" href="classAccessoryGroup.html#a4cc4bd361ef72fe054ad75e9e007b9a0">  140</a></span>&#160;        <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classAccessoryGroup.html#a4cc4bd361ef72fe054ad75e9e007b9a0">AddState</a>(<a class="code" href="classGroupState.html">GroupState</a> *inpState) { this-&gt;States.<a class="code" href="classACCSCHAINEDLIST.html#a57717781c95414794910f53b0500ea3d">AddItem</a>(inpState); }</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;</div><div class="line"><a name="l00146"></a><span class="lineno"><a class="line" href="classAccessoryGroup.html#a68a7051a1ad6d5d389cd71e6f289ddf4">  146</a></span>&#160;        <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classAccessoryGroup.html#a68a7051a1ad6d5d389cd71e6f289ddf4">AddState</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, <span class="keywordtype">bool</span> inSynchronous = <span class="keyword">true</span>) { this-&gt;States.<a class="code" href="classACCSCHAINEDLIST.html#a57717781c95414794910f53b0500ea3d">AddItem</a>(<span class="keyword">new</span> <a class="code" href="classGroupState.html">GroupState</a>(inId, inSynchronous)); }</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classAccessoryGroup.html#a0c773ab063b3d8dc175a4fdd4bc37dbf">AddStateItem</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, <a class="code" href="classAccessory.html">Accessory</a> &amp;inAccessory, ACC_STATE inState, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> inDelay = 0);</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classAccessoryGroup.html#ae8a5619af703b0bab9b8fe7236e057d0">AddRange</a>(<span class="keyword">const</span> <a class="code" href="classAccessoryGroup.html">AccessoryGroup</a> &amp;inGroup);</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        <a class="code" href="classGroupState.html">GroupState</a> *<a class="code" href="classAccessoryGroup.html#a44a43ba4687d9cd3863ec9d1f9a55cde">GetByID</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId) <span class="keyword">const</span>;</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        <a class="code" href="classACCSCHAINEDLISTITEM.html">ACCSCHAINEDLISTITEM&lt;GroupState&gt;</a> *<a class="code" href="classAccessoryGroup.html#ab6ba5894c5a5fc03e1be8db5a0cd4a90">GetItemByID</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId) <span class="keyword">const</span>;</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classAccessoryGroup.html#aa8b6473e417837efbe8dfd8c0221a6a0">Event</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, ACCESSORIES_EVENT_TYPE inEvent = ACCESSORIES_EVENT_MOVEPOSITIONID, <span class="keywordtype">int</span> inData = 0);</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classAccessoryGroup.html#ab9322f8e1511e5545bbd4bee7077291d">EventAll</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, ACCESSORIES_EVENT_TYPE inEvent = ACCESSORIES_EVENT_MOVEPOSITIONID, <span class="keywordtype">int</span> inData = 0);</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classAccessoryGroup.html#aa7161fb1c8e33b10008cd70e373bdff2">StartAction</a>(<a class="code" href="classGroupState.html">GroupState</a> *inpState);</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;</div><div class="line"><a name="l00195"></a><span class="lineno"><a class="line" href="classAccessoryGroup.html#a5a114a8a2d2b0412f5b0acc2813e5545">  195</a></span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classAccessoryGroup.html#a5a114a8a2d2b0412f5b0acc2813e5545">ResetAction</a>()  { this-&gt;States.<a class="code" href="classACCSCHAINEDLIST.html#ac7147ad27413bf0439855df743886053">ResetCurrent</a>(); }</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="classAccessoryGroup.html#a47a16211e59138801c734a445867d137">IsActionItemPending</a>();</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="classAccessoryGroup.html#af218475c80604838386e6a1ae342f88c">loop</a>();</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="classAccessoryGroup.html#af48bad3fa19a9aa30a39c827b57140e4">Toggle</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId);</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;<span class="preprocessor">#ifndef NO_EEPROM</span></div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;        <span class="keywordtype">int</span> <a class="code" href="classAccessoryGroup.html#aa872b142ab9d2c35a6b7db675e2d480a">EEPROMSave</a>(<span class="keywordtype">int</span> inPos, <span class="keywordtype">bool</span> inSimulate = <span class="keyword">false</span>);</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;        <span class="keywordtype">int</span> <a class="code" href="classAccessoryGroup.html#a7a552fc64261c5c812ce152ee80ab291">EEPROMLoad</a>(<span class="keywordtype">int</span> inPos);</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classAccessoryGroup.html#a4e51991ec66066df63057550b79febd9">loops</a>();</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;        <span class="keyword">static</span> uint8_t <a class="code" href="classAccessoryGroup.html#a5c852b40b4303445aaf77bfd03095b1f">GetCount</a>();</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">int</span> <a class="code" href="classAccessoryGroup.html#a414d80944dab2b6ee852fac72e2139d7">EEPROMSaveAll</a>(<span class="keywordtype">int</span> inPos, <span class="keywordtype">bool</span> inSimulate = <span class="keyword">false</span>);</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">int</span> <a class="code" href="classAccessoryGroup.html#a0dac6d80624d22f75d7e5612f2ac34cf">EEPROMLoadAll</a>(<span class="keywordtype">int</span> inPos);</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_PRINT_ACCESSORIES</span></div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">void</span> printGroups();</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;        <span class="keywordtype">void</span> printAccessory();</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;};</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="ttc" id="classAccessoryGroup_html_a0dac6d80624d22f75d7e5612f2ac34cf"><div class="ttname"><a href="classAccessoryGroup.html#a0dac6d80624d22f75d7e5612f2ac34cf">AccessoryGroup::EEPROMLoadAll</a></div><div class="ttdeci">static int EEPROMLoadAll(int inPos)</div></div>
<div class="ttc" id="classAccessoryGroup_html_a414d80944dab2b6ee852fac72e2139d7"><div class="ttname"><a href="classAccessoryGroup.html#a414d80944dab2b6ee852fac72e2139d7">AccessoryGroup::EEPROMSaveAll</a></div><div class="ttdeci">static int EEPROMSaveAll(int inPos, bool inSimulate = false)</div></div>
<div class="ttc" id="classAccessoryGroup_html_a5c852b40b4303445aaf77bfd03095b1f"><div class="ttname"><a href="classAccessoryGroup.html#a5c852b40b4303445aaf77bfd03095b1f">AccessoryGroup::GetCount</a></div><div class="ttdeci">static uint8_t GetCount()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00215">AccessoryGroup.cpp:215</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_a4e51991ec66066df63057550b79febd9"><div class="ttname"><a href="classAccessoryGroup.html#a4e51991ec66066df63057550b79febd9">AccessoryGroup::loops</a></div><div class="ttdeci">static bool loops()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00294">AccessoryGroup.cpp:294</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_aa872b142ab9d2c35a6b7db675e2d480a"><div class="ttname"><a href="classAccessoryGroup.html#aa872b142ab9d2c35a6b7db675e2d480a">AccessoryGroup::EEPROMSave</a></div><div class="ttdeci">int EEPROMSave(int inPos, bool inSimulate = false)</div></div>
<div class="ttc" id="classAccessoryGroup_html_af218475c80604838386e6a1ae342f88c"><div class="ttname"><a href="classAccessoryGroup.html#af218475c80604838386e6a1ae342f88c">AccessoryGroup::loop</a></div><div class="ttdeci">bool loop()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00281">AccessoryGroup.cpp:281</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_a47a16211e59138801c734a445867d137"><div class="ttname"><a href="classAccessoryGroup.html#a47a16211e59138801c734a445867d137">AccessoryGroup::IsActionItemPending</a></div><div class="ttdeci">bool IsActionItemPending()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00252">AccessoryGroup.cpp:252</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_a5a114a8a2d2b0412f5b0acc2813e5545"><div class="ttname"><a href="classAccessoryGroup.html#a5a114a8a2d2b0412f5b0acc2813e5545">AccessoryGroup::ResetAction</a></div><div class="ttdeci">void ResetAction()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8hpp_source.html#l00195">AccessoryGroup.hpp:195</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_ab9322f8e1511e5545bbd4bee7077291d"><div class="ttname"><a href="classAccessoryGroup.html#ab9322f8e1511e5545bbd4bee7077291d">AccessoryGroup::EventAll</a></div><div class="ttdeci">static void EventAll(unsigned long inId, ACCESSORIES_EVENT_TYPE inEvent = ACCESSORIES_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00314">AccessoryGroup.cpp:314</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_ab6ba5894c5a5fc03e1be8db5a0cd4a90"><div class="ttname"><a href="classAccessoryGroup.html#ab6ba5894c5a5fc03e1be8db5a0cd4a90">AccessoryGroup::GetItemByID</a></div><div class="ttdeci">ACCSCHAINEDLISTITEM&lt; GroupState &gt; * GetItemByID(unsigned long inId) const </div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00238">AccessoryGroup.cpp:238</a></div></div>
<div class="ttc" id="classACCSCHAINEDLISTITEM_html"><div class="ttname"><a href="classACCSCHAINEDLISTITEM.html">ACCSCHAINEDLISTITEM&lt; GroupState &gt;</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_a44a43ba4687d9cd3863ec9d1f9a55cde"><div class="ttname"><a href="classAccessoryGroup.html#a44a43ba4687d9cd3863ec9d1f9a55cde">AccessoryGroup::GetByID</a></div><div class="ttdeci">GroupState * GetByID(unsigned long inId) const </div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00228">AccessoryGroup.cpp:228</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_ae8a5619af703b0bab9b8fe7236e057d0"><div class="ttname"><a href="classAccessoryGroup.html#ae8a5619af703b0bab9b8fe7236e057d0">AccessoryGroup::AddRange</a></div><div class="ttdeci">void AddRange(const AccessoryGroup &amp;inGroup)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00204">AccessoryGroup.cpp:204</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_a0c773ab063b3d8dc175a4fdd4bc37dbf"><div class="ttname"><a href="classAccessoryGroup.html#a0c773ab063b3d8dc175a4fdd4bc37dbf">AccessoryGroup::AddStateItem</a></div><div class="ttdeci">void AddStateItem(unsigned long inId, Accessory &amp;inAccessory, ACC_STATE inState, unsigned int inDelay = 0)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00171">AccessoryGroup.cpp:171</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_a68a7051a1ad6d5d389cd71e6f289ddf4"><div class="ttname"><a href="classAccessoryGroup.html#a68a7051a1ad6d5d389cd71e6f289ddf4">AccessoryGroup::AddState</a></div><div class="ttdeci">void AddState(unsigned long inId, bool inSynchronous = true)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8hpp_source.html#l00146">AccessoryGroup.hpp:146</a></div></div>
<div class="ttc" id="classACCSCHAINEDLIST_html_a57717781c95414794910f53b0500ea3d"><div class="ttname"><a href="classACCSCHAINEDLIST.html#a57717781c95414794910f53b0500ea3d">ACCSCHAINEDLIST::AddItem</a></div><div class="ttdeci">void AddItem(T *t)</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00071">Chain.hpp:71</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_a4cc4bd361ef72fe054ad75e9e007b9a0"><div class="ttname"><a href="classAccessoryGroup.html#a4cc4bd361ef72fe054ad75e9e007b9a0">AccessoryGroup::AddState</a></div><div class="ttdeci">void AddState(GroupState *inpState)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8hpp_source.html#l00140">AccessoryGroup.hpp:140</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_a1ba534d4bee2acdb03fa9fbd94d4c871"><div class="ttname"><a href="classAccessoryGroup.html#a1ba534d4bee2acdb03fa9fbd94d4c871">AccessoryGroup::begin</a></div><div class="ttdeci">void begin()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00164">AccessoryGroup.cpp:164</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_aa7161fb1c8e33b10008cd70e373bdff2"><div class="ttname"><a href="classAccessoryGroup.html#aa7161fb1c8e33b10008cd70e373bdff2">AccessoryGroup::StartAction</a></div><div class="ttdeci">void StartAction(GroupState *inpState)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00257">AccessoryGroup.cpp:257</a></div></div>
<div class="ttc" id="classAccessoryGroup_html"><div class="ttname"><a href="classAccessoryGroup.html">AccessoryGroup</a></div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8hpp_source.html#l00120">AccessoryGroup.hpp:120</a></div></div>
<div class="ttc" id="classGroupState_html_a5d3809e4d9e2bcf71f64a32e4152ebb4"><div class="ttname"><a href="classGroupState.html#a5d3809e4d9e2bcf71f64a32e4152ebb4">GroupState::Add</a></div><div class="ttdeci">void Add(Accessory *inpAccessory, ACC_STATE inState, unsigned int inDelay = 0)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00076">AccessoryGroup.cpp:76</a></div></div>
<div class="ttc" id="classGroupState_html_aff83f7f1ac81f36355ead09c92ea093c"><div class="ttname"><a href="classGroupState.html#aff83f7f1ac81f36355ead09c92ea093c">GroupState::loop</a></div><div class="ttdeci">void loop()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00112">AccessoryGroup.cpp:112</a></div></div>
<div class="ttc" id="classGroupState_html_a8500c1d72dacb2c210cb243ab6ad849d"><div class="ttname"><a href="classGroupState.html#a8500c1d72dacb2c210cb243ab6ad849d">GroupState::GetId</a></div><div class="ttdeci">unsigned long GetId() const </div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8hpp_source.html#l00095">AccessoryGroup.hpp:95</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_aa8b6473e417837efbe8dfd8c0221a6a0"><div class="ttname"><a href="classAccessoryGroup.html#aa8b6473e417837efbe8dfd8c0221a6a0">AccessoryGroup::Event</a></div><div class="ttdeci">void Event(unsigned long inId, ACCESSORIES_EVENT_TYPE inEvent = ACCESSORIES_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00339">AccessoryGroup.cpp:339</a></div></div>
<div class="ttc" id="classACCSCHAINEDLIST_html_aec3d93b7e6c96031af848629d72905bd"><div class="ttname"><a href="classACCSCHAINEDLIST.html#aec3d93b7e6c96031af848629d72905bd">ACCSCHAINEDLIST::HasCurrent</a></div><div class="ttdeci">bool HasCurrent()</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00059">Chain.hpp:59</a></div></div>
<div class="ttc" id="classGroupState_html_a447de3adf2c1d8e069d1e6480dec9956"><div class="ttname"><a href="classGroupState.html#a447de3adf2c1d8e069d1e6480dec9956">GroupState::IsActionItemPending</a></div><div class="ttdeci">bool IsActionItemPending()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8hpp_source.html#l00090">AccessoryGroup.hpp:90</a></div></div>
<div class="ttc" id="classACCSCHAINEDLIST_html_ac7147ad27413bf0439855df743886053"><div class="ttname"><a href="classACCSCHAINEDLIST.html#ac7147ad27413bf0439855df743886053">ACCSCHAINEDLIST::ResetCurrent</a></div><div class="ttdeci">void ResetCurrent()</div><div class="ttdef"><b>Definition:</b> <a href="Chain_8hpp_source.html#l00053">Chain.hpp:53</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_af48bad3fa19a9aa30a39c827b57140e4"><div class="ttname"><a href="classAccessoryGroup.html#af48bad3fa19a9aa30a39c827b57140e4">AccessoryGroup::Toggle</a></div><div class="ttdeci">bool Toggle(unsigned long inId)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00344">AccessoryGroup.cpp:344</a></div></div>
<div class="ttc" id="classGroupState_html_ad9503817779a2774923562e80e812a37"><div class="ttname"><a href="classGroupState.html#ad9503817779a2774923562e80e812a37">GroupState::ResetAction</a></div><div class="ttdeci">void ResetAction()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8hpp_source.html#l00085">AccessoryGroup.hpp:85</a></div></div>
<div class="ttc" id="classGroupState_html_acf65dca9f5cb8a4ef1f1a07ab0a888b2"><div class="ttname"><a href="classGroupState.html#acf65dca9f5cb8a4ef1f1a07ab0a888b2">GroupState::StartAction</a></div><div class="ttdeci">void StartAction()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00081">AccessoryGroup.cpp:81</a></div></div>
<div class="ttc" id="classGroupState_html_a97d7335581b8417e3a4ebf7632d6292c"><div class="ttname"><a href="classGroupState.html#a97d7335581b8417e3a4ebf7632d6292c">GroupState::begin</a></div><div class="ttdeci">void begin()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8cpp_source.html#l00054">AccessoryGroup.cpp:54</a></div></div>
<div class="ttc" id="classGroupState_html_abd63266166b098086d0ccebf98b0e269"><div class="ttname"><a href="classGroupState.html#abd63266166b098086d0ccebf98b0e269">GroupState::GroupState</a></div><div class="ttdeci">GroupState()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8hpp_source.html#l00065">AccessoryGroup.hpp:65</a></div></div>
<div class="ttc" id="classACCSCHAINEDLIST_html"><div class="ttname"><a href="classACCSCHAINEDLIST.html">ACCSCHAINEDLIST&lt; GroupStateItem &gt;</a></div></div>
<div class="ttc" id="classGroupStateItem_html_afd18dc4751ac00a4e9e2e824773b108f"><div class="ttname"><a href="classGroupStateItem.html#afd18dc4751ac00a4e9e2e824773b108f">GroupStateItem::GroupStateItem</a></div><div class="ttdeci">GroupStateItem(Accessory *inpAccessory, ACC_STATE inState, unsigned int inDelay = 0)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8hpp_source.html#l00035">AccessoryGroup.hpp:35</a></div></div>
<div class="ttc" id="classGroupStateItem_html_aeff7b5a373dbb6fbf6d2ec27ae846fa1"><div class="ttname"><a href="classGroupStateItem.html#aeff7b5a373dbb6fbf6d2ec27ae846fa1">GroupStateItem::GroupStateItem</a></div><div class="ttdeci">GroupStateItem()</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8hpp_source.html#l00029">AccessoryGroup.hpp:29</a></div></div>
<div class="ttc" id="classAccessory_html"><div class="ttname"><a href="classAccessory.html">Accessory</a></div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00140">Accessory.hpp:140</a></div></div>
<div class="ttc" id="classAccessoryGroup_html_a7a552fc64261c5c812ce152ee80ab291"><div class="ttname"><a href="classAccessoryGroup.html#a7a552fc64261c5c812ce152ee80ab291">AccessoryGroup::EEPROMLoad</a></div><div class="ttdeci">int EEPROMLoad(int inPos)</div></div>
<div class="ttc" id="classGroupState_html"><div class="ttname"><a href="classGroupState.html">GroupState</a></div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8hpp_source.html#l00048">AccessoryGroup.hpp:48</a></div></div>
<div class="ttc" id="classGroupStateItem_html"><div class="ttname"><a href="classGroupStateItem.html">GroupStateItem</a></div><div class="ttdef"><b>Definition:</b> <a href="AccessoryGroup_8hpp_source.html#l00015">AccessoryGroup.hpp:15</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d41d8cd98f00b204e9800998ecf8427e.html">src</a></li><li class="navelem"><b>AccessoryGroup.hpp</b></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:44:46 for Accessories &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
